AbstractListModel (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing, class: AbstractListModel
Keywords: javax.swing.AbstractListModel class

# Class AbstractListModel<E>

java.lang.Object
javax.swing.AbstractListModel<E>

Type Parameters:
  `E` - the type of the elements of this model

All Implemented Interfaces:
  `Serializable, ListModel<E>`

Direct Known Subclasses:
  `BasicDirectoryModel, DefaultComboBoxModel, DefaultListModel, MetalFileChooserUI.DirectoryComboBoxModel, MetalFileChooserUI.FilterComboBoxModel`

public abstract class AbstractListModel<E> extends Object implements ListModel<E>, Serializable
The abstract definition for the data model that provides a `List` with its contents.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

Since:
  1.2

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected EventListenerList`
  `listenerList`
  The listener list.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractListModel()`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListDataListener(ListDataListener l)`
  Adds a listener to the list that's notified each time a change to the data model occurs.
  `protected void`
  `fireContentsChanged(Object source, int index0, int index1)`
  `AbstractListModel` subclasses must call this method after one or more elements of the list change.
  `protected void`
  `fireIntervalAdded(Object source, int index0, int index1)`
  `AbstractListModel` subclasses must call this method after one or more elements are added to the model.
  `protected void`
  `fireIntervalRemoved(Object source, int index0, int index1)`
  `AbstractListModel` subclasses must call this method after one or more elements are removed from the model.
  `ListDataListener[]`
  `getListDataListeners()`
  Returns an array of all the list data listeners registered on this `AbstractListModel`.
  `<T extends EventListener>
  T[]`
  `getListeners(Class<T> listenerType)`
  Returns an array of all the objects currently registered as `FooListener`s upon this model.
  `void`
  `removeListDataListener(ListDataListener l)`
  Removes a listener from the list that's notified each time a change to the data model occurs.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface ListModel

  `getElementAt, getSize`
  Modifier and Type
  Method
  Description
  `E`
  `getElementAt(int index)`
  Returns the value at the specified index.
  `int`
  `getSize()`
  Returns the length of the list.

- ## Field Details

  - ### listenerList

    protected EventListenerList listenerList
    The listener list.

- ## Constructor Details

  - ### AbstractListModel

    protected AbstractListModel()
    Constructor for subclasses to call.

- ## Method Details

  - ### addListDataListener

    public void addListDataListener(ListDataListener l)
    Adds a listener to the list that's notified each time a change to the data model occurs.
    Specified by:
      `addListDataListener` in interface `ListModel<E>`
    Parameters:
      `l` - the `ListDataListener` to be added

  - ### removeListDataListener

    public void removeListDataListener(ListDataListener l)
    Removes a listener from the list that's notified each time a change to the data model occurs.
    Specified by:
      `removeListDataListener` in interface `ListModel<E>`
    Parameters:
      `l` - the `ListDataListener` to be removed

  - ### getListDataListeners

    public ListDataListener[] getListDataListeners()
    Returns an array of all the list data listeners registered on this `AbstractListModel`.
    Returns:
      all of this model's `ListDataListener`s, or an empty array if no list data listeners are currently registered
    Since:
      1.4
    See Also:
      - `addListDataListener(ListDataListener)`
      - `removeListDataListener(ListDataListener)`

  - ### fireContentsChanged

    protected void fireContentsChanged(Object source, int index0, int index1)
    `AbstractListModel` subclasses must call this method after one or more elements of the list change. The changed elements are specified by the closed interval index0, index1 -- the endpoints are included. Note that index0 need not be less than or equal to index1.
    Parameters:
      `source` - the `ListModel` that changed, typically "this"
      `index0` - one end of the new interval
      `index1` - the other end of the new interval
    See Also:
      - `EventListenerList`
      - `DefaultListModel`

  - ### fireIntervalAdded

    protected void fireIntervalAdded(Object source, int index0, int index1)
    `AbstractListModel` subclasses must call this method after one or more elements are added to the model. The new elements are specified by a closed interval index0, index1 -- the endpoints are included. Note that index0 need not be less than or equal to index1.
    Parameters:
      `source` - the `ListModel` that changed, typically "this"
      `index0` - one end of the new interval
      `index1` - the other end of the new interval
    See Also:
      - `EventListenerList`
      - `DefaultListModel`

  - ### fireIntervalRemoved

    protected void fireIntervalRemoved(Object source, int index0, int index1)
    `AbstractListModel` subclasses must call this method after one or more elements are removed from the model. `index0` and `index1` are the end points of the interval that's been removed. Note that `index0` need not be less than or equal to `index1`.
    Parameters:
      `source` - the `ListModel` that changed, typically "this"
      `index0` - one end of the removed interval, including `index0`
      `index1` - the other end of the removed interval, including `index1`
    See Also:
      - `EventListenerList`
      - `DefaultListModel`

  - ### getListeners

    public <T extends EventListener> T[] getListeners(Class<T> listenerType)
    Returns an array of all the objects currently registered as `FooListener`s upon this model. `FooListener`s are registered using the `addFooListener` method.

    You can specify the `listenerType` argument with a class literal, such as `FooListener.class`. For example, you can query a list model `m` for its list data listeners with the following code:

        ListDataListener[] ldls = (ListDataListener[])(m.getListeners(ListDataListener.class));

    If no such listeners exist, this method returns an empty array.
    Type Parameters:
      `T` - the type of `EventListener` class being requested
    Parameters:
      `listenerType` - the type of listeners requested; this parameter should specify an interface that descends from `java.util.EventListener`
    Returns:
      an array of all objects registered as `FooListener`s on this model, or an empty array if no such listeners have been added
    Throws:
      `ClassCastException` - if `listenerType` doesn't specify a class or interface that implements `java.util.EventListener`
    Since:
      1.3
    See Also:
      - `getListDataListeners()`